<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
        "http://www.w3.org/TR/html4/strict.dtd"><html>
    <head>
        <meta http-equiv="content-type" content="text/html; charset=utf-8">
        <title>Example: Listening For Menu Events (YUI Library)</title>

                <!-- Standard reset and fonts -->

        <link rel="stylesheet" type="text/css" href="../../build/reset/reset.css">
        <link rel="stylesheet" type="text/css" href="../../build/fonts/fonts.css">

            

        <!-- Logger CSS -->

        <link rel="stylesheet" type="text/css" href="../../build/logger/assets/logger.css">

         

        <!-- CSS for Menu -->

        <link rel="stylesheet" type="text/css" href="../../build/menu/assets/menu.css">
 

        <!-- Page-specific styles -->

        <style type="text/css">

            body { margin:.5em; }

            h1 { font-weight:bold; }

            p em {
            
                text-decoration:underline;
            
            }

            #logs {

                position:absolute;
                bottom:0;
                right:0;
            
            }

            .example10 {

                background-color:#9c9;
            
            }

            p#clicknote {

                margin-top:1em;

            }

            p#clicknote em {
            
                font-weight:bold;
            
            }

        </style>
        
                <!-- Namespace source file -->

        <script type="text/javascript" src="../../build/yahoo/yahoo.js"></script>

        <!-- Dependency source files -->

        <script type="text/javascript" src="../../build/event/event.js"></script>
        <script type="text/javascript" src="../../build/dom/dom.js"></script>

            

        <!-- Logger source file -->

        <script type="text/javascript" src="../../build/logger/logger.js"></script>
        
        <!-- Container source file -->
        <script type="text/javascript" src="../../build/container/container_core.js"></script>

        <!-- Menu source file -->
        <script type="text/javascript" src="../../build/menu/menu.js"></script>
        
        <!-- Page-specific script -->

        <script type="text/javascript">

            // "load" event handler for the window

            YAHOO.example.onWindowLoad = function(p_oEvent) {

                // Generic event handler for the menu events
                
                function onMenuEvent(p_sType, p_aArguments) {
                
                    var oDOMEvent = p_aArguments[0];
    
                    YAHOO.log(
                        (
                        "Id: " + this.id + ", " +
                        "Custom Event Type: " + p_sType + ", " +                  
                        "DOM Event Type: " + oDOMEvent.type
                        ),
                        "info",
                        "example10"
                    );
                }
    
    
                // Generic event handler for the menu item events
    
                function onMenuItemEvent(p_sType, p_aArguments) {
    
                    var oDOMEvent = p_aArguments[0];
    
                    YAHOO.log(
                        (
                        "Index: " + this.index + ", " +
                        "Group Index: " + this.groupIndex + ", " +
                        "Custom Event Type: " + p_sType + ", " +                  
                        "DOM Event Type: " + oDOMEvent.type
                        ),
                        "info",
                        "example10"
                    );
                    
                }


                // Create a menu

                var oMenu = new YAHOO.widget.Menu("basicmenu"),

                    // Create the MenuItem instances and add them to the menu

                    aMenuItemData = [
                
                        "MenuItem 0",
                        "MenuItem 1",
                        "MenuItem 2",
                        "MenuItem 3",
                        "MenuItem 4"

                    ],

                    nMenuItems = aMenuItemData.length,

                    oMenuItem;
                


                for(var i=0; i<nMenuItems; i++) {

                    oMenuItem = oMenu.addItem(aMenuItemData[i]);

                    oMenuItem.mouseOverEvent.subscribe(onMenuItemEvent);
                    oMenuItem.mouseOutEvent.subscribe(onMenuItemEvent);
                    oMenuItem.mouseDownEvent.subscribe(onMenuItemEvent);
                    oMenuItem.mouseUpEvent.subscribe(onMenuItemEvent);
                    oMenuItem.clickEvent.subscribe(onMenuItemEvent);
                    oMenuItem.keyDownEvent.subscribe(onMenuItemEvent);
                    oMenuItem.keyUpEvent.subscribe(onMenuItemEvent);
                    oMenuItem.keyPressEvent.subscribe(onMenuItemEvent);

                }

                oMenu.render(document.body);
    
                oMenu.show();


                // Focus the first menu item

                oMenu.getItem(0).focus();
                

                // Disable the third menu item instance

                oMenu.getItem(2).cfg.setProperty("disabled", true);


                // Subscribe to the menu's events

                oMenu.mouseOverEvent.subscribe(onMenuEvent);
                oMenu.mouseOutEvent.subscribe(onMenuEvent);
                oMenu.mouseDownEvent.subscribe(onMenuEvent);
                oMenu.mouseUpEvent.subscribe(onMenuEvent);
                oMenu.clickEvent.subscribe(onMenuEvent);
                oMenu.keyDownEvent.subscribe(onMenuEvent);
                oMenu.keyUpEvent.subscribe(onMenuEvent);
                oMenu.keyPressEvent.subscribe(onMenuEvent);


                var oLogs = document.createElement("div");
                oLogs.id = "logs";
                
                document.body.appendChild(oLogs);

                var oLogReader = new YAHOO.widget.LogReader("logs");


                function onMenuToggleMouseDown(p_oEvent) {

                    YAHOO.util.Event.stopPropagation(p_oEvent);
                                    
                    oMenu.show();
                
                }

                YAHOO.util.Event.addListener("menutoggle", "mousedown", onMenuToggleMouseDown);


                /*
                     Add a "mousedown" event handler to prevent the menu from 
                     hiding when the user mouses down on the logger.
                */

                function onLogsMouseDown(p_oEvent) {

                    YAHOO.util.Event.stopPropagation(p_oEvent);

                }

                YAHOO.util.Event.addListener("logs", "mousedown", onLogsMouseDown);

            }


            YAHOO.util.Event.addListener(window, "load", YAHOO.example.onWindowLoad);
            
        </script>
        
    </head>
    <body>

        <h1>Example: Listening For Menu Events (YUI Library) <em>[<a href="index.html">Examples Home</a>]</em></h1>
        <p>This example demonstrates how to listen for DOM-related events.  Interaction with the Menu will result in event information being output to the console.  <em>Please note</em>: Disabled MenuItem instances do not fire DOM events.  This is demonstrated with the MenuItem named "MenuItem 2."</p>
        <p id="clicknote"><em>Note:</em> By default clicking outside of a menu will hide it.  Additionally, menu items without a submenu or a URL to navigate will hide their parent menu when clicked.  Click the "Show Menu" button below to make the menu visible if it is hidden.</p>
        <button id="menutoggle">Show Menu</button>

    </body>
</html>